#!/usr/bin/env python
# -*- coding: utf-8 -*-

from os import system
from sys import exit

import gobject
import dbus
import dbus.mainloop.glib

progreso = 0

def usplash(arg, txt=None):
    system('/sbin/usplash_write "%s %s"' % (arg, txt if txt else ""))

def escribe(t):
    usplash("TEXT", t)

def senyal_progreso(arg):
    global progreso
    if arg/10 > progreso:
        progreso = arg/10
        usplash("PROGRESS", progreso*10)
        usplash("CLEAR")
        escribe("Sincronizando los datos del usuario... %d %%" % (progreso*10))

def senyal_estado(arg):
    escribe("Sincronizacion finalizada.")
    loop.quit()

usplash("TIMEOUT", "0")
usplash("VERBOSE", "on")
usplash("PULSATE")
escribe("Sincronizando la informacion del usuario")

dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
bus = dbus.SystemBus()
bus.add_signal_receiver(senyal_progreso, dbus_interface = "cga.nfssyncd.dbus.Signal", signal_name = "RSYNC_PROG")
bus.add_signal_receiver(senyal_estado, dbus_interface = "cga.nfssyncd.dbus.Signal", signal_name = "RSYNC_STATUS")

comando = "/usr/sbin/cga-end-session"
res=system(comando)
if res != 0:
    escribe("Error al ejecutar cga-end-session")
    exit(1)

loop = gobject.MainLoop()
loop.run()

